;------------------------------------------------------------------------------
; Oldschoolengine general API defines
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
; Program entry point
;------------------------------------------------------------------------------

entrypoint      = $0300

;------------------------------------------------------------------------------
; Stack pointers for main & interrupts
;------------------------------------------------------------------------------

MAIN_SP         = $df
IRQ_SP          = $ff

;------------------------------------------------------------------------------
; GBA directional pad & buttons (API call $0d)
;------------------------------------------------------------------------------

        ;Returned in A

JOY_UP          = 1
JOY_DOWN        = 2
JOY_LEFT        = 4
JOY_RIGHT       = 8
JOY_FIRE1       = 16
JOY_FIRE2       = 32

        ;Returned in X

JOY_L           = 1
JOY_R           = 2
JOY_SELECT      = 4
JOY_START       = 8

;------------------------------------------------------------------------------
; API function numbers
;------------------------------------------------------------------------------

C_DEBUGHALT     = $00
C_REDRAW        = $01
C_SETSCREENBASE = $02
C_SETCOLORBASE  = $03
C_SETCHARBASE   = $04
C_SETSPRITEBASE = $05
C_SETSIDBASE    = $06
C_SETGAMECOLORS = $07
C_SETSCORECOLORS = $08
C_SETGAMESCROLL = $09
C_PRINTOVERLAY  = $0a
C_SETSPRITECOLORS = $0b
C_SETSPRITELIST = $0c
C_GETCONTROLS   = $0d
C_SETBLITTERSRC = $0e
C_SETBLITTERDEST = $0f
C_RUNBLITTER    = $10
C_SETVBLANKROUTINE = $11
C_SETPLAYROUTINE = $12
C_OPENFILE      = $13
C_GETBYTE       = $14
C_LOADSUBFILE   = $15
C_SETSAVESTATESTART = $16
C_SETSAVESTATESIZE = $17
C_LOADSTATE     = $18
C_SAVESTATE     = $19
C_RANDOM        = $1a

;------------------------------------------------------------------------------
; API function call macro
;------------------------------------------------------------------------------

                MAC callapi
                brk
                dc.b {1}
                ENDM


