JOY_FIRE        = JOY_FIRE2
JOY_JUMP        = JOY_FIRE1
JOY_ACTIVATE    = $80           ;Fake control for forced sidedoor entry

KEY_L           = $01
KEY_R           = $02
KEY_SELECT      = $03
KEY_START       = $04
KEY_NONE        = $ff

;-------------------------------------------------------------------------------
; GETCONTROLS
;
; Reads joystick + scans the keyboard.
;
; Parameters: -
; Returns: -
; Modifies: A
;-------------------------------------------------------------------------------

getcontrols:    lda joystick
                sta prevjoy
                lda keypress
                sta prevkeys
                callapi C_GETCONTROLS
                sta joystick
                stx keypress
                lda prevkeys
                bne getcontrolsnokey
                txa
                ldx #KEY_L
                lsr
                bcs getcontrolsok
                inx
                lsr
                bcs getcontrolsok
                inx
                lsr 
                bcs getcontrolsok
                inx
                lsr
                bcs getcontrolsok
getcontrolsnokey:
                ldx #KEY_NONE
getcontrolsok:  stx keytype
                rts

;-------------------------------------------------------------------------------
; GETFIRECLICK
;
; Checks if fire button has been pressed shortly.
;
; Parameters: -
; Returns: C=0 not pressed, C=1 pressed
; Modifies: A
;-------------------------------------------------------------------------------

getfireclick:   clc
                lda prevjoy
                and #JOY_FIRE|JOY_JUMP
                bne gfc_not
                lda joystick
                and #JOY_FIRE|JOY_JUMP
                beq gfc_not
                sec
gfc_not:        rts
