SCROLLROWS      = 21                          ;Amount of scrolling rows

NUMGAMES        = 7                             ;Savegames
NUMBLOCKS       = 128
NUMSPRFILES     = 31
NUMSPR          = 32
NUMGRP          = 7                             ;Number of "groups" in game
NUMACT          = 22
NUMDEPACKSPR    = NUMACT
NUMCOMPLEXACT   = 7
NUMLEVELS       = 27                            ;Max. levels in game
NUMLVLACT       = 470
NUMLVLOBJ       = 128                           ;Max. objects in a level
NUMZONES        = 32                            ;Max. zones in a level
NUMRANDOMACT    = 16                            ;Random actor definitions
NUMPLOTBITS     = 80                            ;Boolean flags for plot state
NUMACTTRIGGER   = 32                            ;Maximum actortriggers
NUMWAYPOINTS    = 3                             ;Max. AI waypoints


NUMWEAPONS      = 24                          ;Max. different weapons
NUMBULLETS      = 24                          ;Max. different bullet types
NUMSPECDMG      = 5                           ;Max. special damage types
NUMITEMS        = 64                          ;Max. items (including weapons)

INVENTORYSIZE   = 48                          ;Player inventory size


FILE_SPRITE     = $01
FILE_SCRIPT     = $20
FILE_MUSIC      = $3e
FILE_LEVEL      = $4b
FILE_TITLE      = $66
FILE_MAP        = $67
FILE_FACES      = $68
FILE_ACTORS     = $69

GAME_AUTOSAVE   = 6


;Ŀ
;Zeropage memory usage                                                        
;

filename        = $02   ;2 letters
ntscdelay       = $04

keypress        = $05
keytype         = $06
joystick        = $07
prevjoy         = $08
prevkeys        = $09

maptemp1        = $0a
maptemp2        = $0b
maptemp3        = $0c
maptemp4        = $0d

basesprpri      = $0e

scrollx         = $0f                           ;Fine scrolling, with 3 bits
scrolly         = $10                           ;subpixel accuracy (0-63)
scrollsx        = $11                           ;Scrolling speed, with 3 bits
scrollsy        = $12                           ;subpixel accuracy
scrcounter      = $13                           ;Scrolling phase variable
blockx          = $14                           ;Upper-left corner position
blocky          = $15                           ;within a block (0-3)
mapx            = $16                           ;Upper-left corner within the
mapy            = $17                           ;map
screen          = $18                           ;Number of gamescreen (0 or 1)
numspr          = $19
sortsprstart    = $1a
sortsprend      = $1b
sortirqstart    = $1c
sortirqend      = $1d
temp1           = $1e
temp2           = $1f
temp3           = $20
temp4           = $21
temp5           = $22
temp6           = $23
temp7           = $24
tempadrlo       = $25
tempadrhi       = $26
sprsubxl        = $27
sprsubxh        = $28
sprsubyl        = $29
sprsubyh        = $2a
actlptrlo       = $2b                           ;Actor logic struct. pointer
actlptrhi       = $2c
actcapbits      = $2d

speedpos        = $2e                           ;Temp for actor move routines
speedneg        = $2f
accelpos        = $30
accelneg        = $31

targetxdist     = $2e                           ;AI routines
targetabsxdist  = $2f
targetydist     = $30
targetabsydist  = $31
targetycompare  = $32
targetactive    = $33
actreactmode    = $34

attackolddir    = $2e                           ;Extra temp variables used by
attackxmod      = $2f                           ;attack routines
ammotype        = $30
oldwf           = $31
cbcrestx        = $32
cbcresty        = $33

actdptrlo       = $2e                           ;Extra temp variables used by
actdptrhi       = $2f                           ;display routines
actfptrlo       = $30
actfptrhi       = $31

msgtime         = $35                           ;Message system counter
choicenum       = $36                           ;Multichoice routine
textwindowrow   = $37                           ;Text window params.
textwindowcolumn = $38
textwindowleft  = $39
textwindowright = $3a
freesprites     = $3b                           ;Free sprites counter

alo             = $3c                           ;Accumulator for multiplication
ahi             = $3d
aonum           = $3e
donum           = $3f
limitl          = $40
limitr          = $41
limitu          = $42
limitd          = $43
lvlactptrlo     = $44                           ;Level actor search pointer
lvlactptrhi     = $45
lvlobjstatptrlo = $46                           ;Pointer to level object status
lvlobjstatptrhi = $47                           ;bits
actrestx        = $48
actresty        = $49

textptrlo       = $4a
textptrhi       = $4b

dmgmullo        = $4c
dmgmulhi        = $4d

sortorder       = $4e
sprpri          = $4e+NUMSPR+1
dsprf           = $4e+(NUMSPR+1)*2
dsprprevf       = $4e+(NUMSPR+1)*2+NUMDEPACKSPR
musicbase       = $4e+(NUMSPR+1)*2+NUMDEPACKSPR*2
musiczpbase     = $4e+(NUMSPR+1)*2+NUMDEPACKSPR*2+3*21

                if musiczpbase > $fb
                  err
                endif

sidbase         = $0200
colorbackup     = $0220

sortsprx        = $0220
sortsprxh       = $0240
sortspry        = $0260
sortsprf        = $0280
sortsprc        = $02a0
spract          = $02c0
sprf            = $02e0
sprc            = $0100
sprx            = $0120
spry            = $0140
maincodestart   = $0300

randomareastart = $2000

scriptarea      = $9700
musicarea       = $9f00
blktbllo        = $a700
blktblhi        = $a780
loadbuffer      = $a800
maptbllo        = $a800
maptblhi        = $a880
map             = $a900
randomacttbl    = $b600
bganimcode      = $b620
blocks          = $b680
blkcoltbl       = $be80
charinfo        = $bf00
videobank       = $c000
textscreen      = $c000
screen1         = $c000
colors          = $c400
vcolbuf         = $c7c0
chars           = $f800
textchars       = $f800


