;-------------------------------------------------------------------------------
; LOADFILERETRY
;
; Loads a file and shows a disk in bottom of screen
; Actually this never retries but halts on error
;
; Parameters: filename, A,X:startaddress
; Returns: -
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

loadfileretry:  jsr showdisk
                jsr loadfile
hidedisk:
hidedisk_ldy:   ldy #$00
                sty textscreen+21*40+69
                jmp redrawoverlay

showdisk:       ldy textscreen+21*40+69
                sty hidedisk_ldy+1
                ldy #";"
                sty textscreen+21*40+69
                jmp redrawoverlay

;-------------------------------------------------------------------------------
; MAKEFILENAME
; MAKEFILENAME_DIRECT
;
; Creates the filename.
;
; Parameters: A:File number (X:File type add in MAKEFILENAME only)
; Returns: filename
; Modifies: A
;-------------------------------------------------------------------------------

makefilename:   stx maptemp1
                clc
                adc maptemp1
makefilename_direct:
makefilename2:  pha
                lsr
                lsr
                lsr
                lsr
                jsr mfn_sub
                sta filename
                pla
                jsr mfn_sub
                sta filename+1
                rts
mfn_sub:        and #$0f
                ora #$30
                cmp #$3a
                bcc mfn_number
                adc #$06
mfn_number:     rts

;-------------------------------------------------------------------------------
; OPENFILE
;
; Opens a file.
;
; Parameters: filename
; Returns: C=1 file not found, C=0 ok
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

openfile:       lda filename
                ldx filename+1
                callapi C_OPENFILE
                rts
                
;-------------------------------------------------------------------------------
; GETBYTE
;
; Gets a byte from an opened file.
;
; Parameters: -
; Returns: C=0 OK, A contains byte
;          C=1 File stream ended
;
; Modifies: A
;-------------------------------------------------------------------------------

getbyte:        callapi C_GETBYTE
                rts

;-------------------------------------------------------------------------------
; LOADFILE
;
; Loads a packed file.
;
; Parameters: A,X:Load address
;             Filename
; Returns: C=0 File loaded OK
;              Otherwise never returns
;
; Modifies: A,X
;-------------------------------------------------------------------------------

loadfile:       sta loadadrlo+1
                stx loadadrhi+1
                jsr openfile
                bcs fileerror
loadadrlo:      lda #$00
loadadrhi:      ldx #$00
                callapi C_LOADSUBFILE
                bcs fileerror
loadfileerror:  rts

;-------------------------------------------------------------------------------
; FILEERROR
;
; Prints the filename on screen & halts
;
; Parameters: -
; Returns: -
; Modifies: A,X,Y
;-------------------------------------------------------------------------------

fileerror:      lda filename
                sta textscreen+23*40+14
                lda filename+1
                sta textscreen+23*40+15
                jsr redrawoverlay
fe_wait:        jmp fe_wait
