                org scriptarea

NUMWEAPONATTRIB = 21                              ;Number of attributes in the
NUMBULLETATTRIB = 13                              ;definitions (for loading)
NUMITEMATTRIB   = 6
NUMSPECDMGATTRIB = 5

;-------------------------------------------------------------------------------
; MW4 New Engine - initialization (discardable)
;-------------------------------------------------------------------------------

initengine:     lda #$0f  
                sta sidbase+$18

initweapons:    ldx #$00
ld_loop:        jsr ld_getbyte
                tay
                bmi ld_loopdone
                jsr dw_common
                jmp ld_loop
ld_loopdone:    inx
                cpx #$04
                bcc ld_loop

initvideo:      lda #$00
                sta joystick                    ;Control reset
                sta prevjoy
                sta keypress
                sta prevkeys
                sta keytype
                sta ntscdelay
                ldx #SPRMC1
                ldy #SPRMC2
                callapi C_SETSPRITECOLORS
                lda #>videobank
                callapi C_SETSPRITEBASE
                lda #>textscreen
                callapi C_SETSCREENBASE
                lda #>colors
                callapi C_SETCOLORBASE
                lda #>textchars
                callapi C_SETCHARBASE
                lda #>sidbase
                callapi C_SETSIDBASE
                lda #$00
                ldx #OVERLAYMC1
                ldy #OVERLAYMC2
                callapi C_SETSCORECOLORS
                lda #<musicirq
                ldx #>musicirq
                callapi C_SETPLAYROUTINE
                lda #<saveareastart
                ldx #>saveareastart
                callapi C_SETSAVESTATESTART
                lda #<(saveareaend-saveareastart)
                ldx #>(saveareaend-saveareastart)
                callapi C_SETSAVESTATESIZE
                lda #$38
                sta scrollx
                sta scrolly

initsprites:    lda #$00
                sta numspr
                sta maptemp1
                tax
                lda #LASTSPRITEFRAME-FIRSTSPRITEFRAME   ;Init free sprite count
                sta freesprites
is_copyfontloop:lda charset,x                   ;Copy charset to its ingame
                sta textchars,x                 ;place
                lda charset+$100,x
                sta textchars+$100,x
                inx
                bne is_copyfontloop

                lda #$00
                ldx #$3f                        ;Make empty spriteframe
is_emptyfrloop:
N               set 0
                repeat NUMDEPACKSPR             ;Clear depacksprites
                sta $c000+FIRSTDEPACKFRAME*64+64*N,x
N               set N+1
                repend
                dex
                bpl is_emptyfrloop

                ldx #NUMDEPACKSPR-1
is_dsprloop:    lda #$ff                        ;Reset depacksystem
                sta dsprf,x
                sta dsprprevf,x
                dex
                bpl is_dsprloop
                ldx #$00
is_spradrloop:  lda dspr_adrlo,x                 ;Add baseaddress to
                clc                             ;depack-spritepointers
                adc #<depacksprdata
                sta dspr_adrlo,x
                lda dspr_adrhi,x
                adc #>depacksprdata
                sta dspr_adrhi,x
                inx
                cpx #(dspr_adrhi-dspr_adrlo)
                bcc is_spradrloop

                ldx #NUMSPR
is_loop:        txa                             ;Create initial sprite order
                sta sortorder,x
                lda #$ff
                sta sprpri,x
                dex
                bpl is_loop
                jsr initscroll

                lda #$60
                sta bganimcode

                jsr cleartextscreen

drawpanel:      ldx #39
dp_loop1:       lda #$20
                sta textscreen+21*40,x
                sta textscreen+22*40,x
                sta textscreen+23*40,x
                sta textscreen+24*40,x
                lda #$01
                sta colors+21*40,x
                sta colors+22*40,x
                sta colors+23*40,x
                sta colors+24*40,x
                dex
                bpl dp_loop1

                lda #21
                ldx #0
dp_overlayloop: callapi C_PRINTOVERLAY
                inx
                cpx #20
                bne dp_overlayloop

                lda #$08
                sta colors+22*40                 ;Weapon indicator colors
                sta colors+22*40+1

                ldx #HEALTHBAR_LENGTH-1
                lda #$08
dp_loop3:       sta colors+23*40+1,x                ;Healthbar colors
                sta colors+23*40+24,x
                dex
                bpl dp_loop3

                lda #HP_AGENT
                sta acthp+ACTI_PLAYER
                sta actbatt+ACTI_PLAYER
                lda #0
                sta invselect
                lda #ITEM_FISTS
                sta invtype

                lda #UPD_SCORE|UPD_ITEM|UPD_AMMO
                sta panelupdateflag
                lda #$00
                sta msgtime
                lda #8
                sta textwindowleft
                lda #30
                sta textwindowright
                jsr cleartextwindow
                jsr resetmessage

                lda #SPRF_COMMON                ;Load common sprites
                jsr loadsprites
                ldx #MAIN_SP
                txs
                lda #>(mainloop-1)              ;Push mainloop address
                pha
                lda #<(mainloop-1)
                pha
                lda #<SCRIPT_TITLE              ;Init titlescreen & jump to
                ldx #>SCRIPT_TITLE              ;mainloop afterwards (this
                jmp execscript                  ;code is overwritten)

dw_common:      lda dwlotbl,x
                sta alo
                lda dwhitbl,x
                sta ahi
                lda dwnumtbl,x
                sta temp1
                lda dwaddtbl,x
                sta temp2
dw_loop:        jsr ld_getbyte
                sta (alo),y
                dec temp1
                beq dw_ready
                lda alo
                clc
                adc temp2
                sta alo
                bcc dw_loop
                inc ahi
                bne dw_loop
dw_ready:       rts

ld_getbyte:     lda wpndefs
                inc ld_getbyte+1
                bne ld_gbok
                inc ld_getbyte+2
ld_gbok:        rts

dwlotbl:        dc.b <wpn_noisetbl, <blt_xmodtbllo, <itemaddtbl, <specdmgcondition
dwhitbl:        dc.b >wpn_noisetbl, >blt_xmodtbllo, >itemaddtbl, >specdmgcondition
dwnumtbl:       dc.b NUMWEAPONATTRIB, NUMBULLETATTRIB, NUMITEMATTRIB, NUMSPECDMGATTRIB
dwaddtbl:       dc.b NUMWEAPONS, NUMBULLETS, NUMITEMS, NUMSPECDMG

initend:
                if initend > musicarea
                err
                endif

charset:
                incbin bg\scorescr.chr


