;
; Script 30: Endscreen
;
                include scriptm.s

                entrypoint es_finalscreen       ;$1e00
                entrypoint es_finalscreenrun    ;$1e01
                entrypoint research             ;$1e02

;-------------------------------------------------------------------------------
; $1e01
;-------------------------------------------------------------------------------

es_finalscreenrun:
                getbit PLOT_MELTDOWN_DONE       ;Sentinels show themselves?
                beq es_fsrfalse
                lda agentcounter
                bne es_noiacinit
                lda #ACTI_LASTNPC
                ldy #ACTI_FIRSTNPC
                jsr getfreeactor
                bcc es_fsrfalse
                lda #ACT_SENTINELIAC
                jsr createactor
                tya
                tax
                lda mapx
                sec
                sbc #$01
                sta actxh,x
                lda mapy
                clc
                adc #$02
                sta actyh,x
                jsr initcomplexactor
                lda #M_FREE
                sta actmode,x
                lda #JOY_RIGHT
                sta actctrl,x
                lda #36
                sta actsx,x
                lda #-24
                sta actsy,x
es_noiacinit:   inc agentcounter
                focus ACT_SENTINELIAC
                bcc es_noctrl
                lda agentcounter
                cmp #20
                bne es_noctrl1
                lda #JOY_RIGHT+JOY_UP
                sta actctrl,x
                rts
es_noctrl1:     cmp #48
                bne es_noctrl2
                lda #JOY_RIGHT
                sta actctrl,x
                rts
es_noctrl2:     lda agentcounter
                cmp #65
                bcs es_fsrfalse
es_noctrl:      rts
es_fsrfalse:    stopscript      ;Fall through

;-------------------------------------------------------------------------------
; $1e00
;-------------------------------------------------------------------------------

es_finalscreen: lda difficulty
                clc
                adc #$01
                asl
                tax
es_bonusloop:   lda #<50000             ;Add 100000 x difficulty level
                ldy #>50000
                jsr addscore
                dex
                bne es_bonusloop
                jsr updatepanel

                lda #STATUS_GAMEOVER
                sta gameon
                lda actt+ACTI_PLAYER
                sta es_acttcmp+1
                jsr initactors
                lda #$00
                sta agentcounter
es_wipeloop:    jsr scriptupdateframe
es_wipeloop2:
                ldy agentcounter
                lda #$00
                sta temp1
                sta temp3
                lda #>colors
                sta temp4
                lda #>screen1
                sta temp2
                ldx #SCROLLROWS
es_wipeloop3:   lda #$40
                sta (temp1),y
                lda #$00
                sta (temp3),y
                lda temp1
                clc
                adc #40
                sta temp1
                sta temp3
                bcc es_wipeok
                inc temp2
                inc temp4
es_wipeok:      dex
                bne es_wipeloop3
                inc agentcounter
                lda agentcounter
                cmp #40
                bcc es_wipeloop

                jsr beginfullscreen
                ldx #FILE_FACES
                lda #$00
                jsr makefilename
                lda #<(chars+$200)
                ldx #>(chars+$200)
                jsr loadfileretry
                lda #$09
                sta rgscr_textbg2+1
                lda #$0a
                sta rgscr_textbg3+1

                ldx #$02
es_copyscore:   lda score,x
                sta temp1,x
                dex
                bpl es_copyscore
                jsr convert24bits
                ldx #15
                lda temp7
                jsr printenddigit
                lda temp6
                jsr printenddigits
                lda temp5
                jsr printenddigits
                lda temp4
                jsr printenddigits
                lda ti_hours
                ldx #37
                jsr printendnumber
                lda ti_minutes
                ldx #40
                jsr printendnumber
                lda ti_seconds
                ldx #43
                jsr printendnumber
                lda #<finaltext2
                ldy #>finaltext2
                jsr printscreentext

                getbit PLOT_JOAN_JOIN   ;Determine ending quote
                jumptrue es_textc
                getbit PLOT_JOAN_DEAD
                jumptrue es_texte
es_texta:
es_acttcmp:     lda #$00
                cmp #ACT_IANCIVILIAN
                beq es_textb
                lda #<finaltexta        ;So Agent, walk on the Chosen Path..
                ldy #>finaltexta        ;(standard)
                bne es_textcommon
es_textb:       lda #<finaltextb        ;I have seen things better left untold..
                ldy #>finaltextb        ;(traitorous)
                bne es_textcommon
es_textc:       getbit PLOT_MELTDOWN_DONE
                jumptrue es_textd
                lda #<finaltextc        ;We have learned that things aren't..
                ldy #>finaltextc        ;(together)
                bne es_textcommon
es_textd:       lda #<finaltextd        ;The Truth is hidden..
                ldy #>finaltextd        ;(sentinels appear)
                bne es_textcommon
es_texte:       lda #<finaltexte        ;When all the enemies have been..
                ldy #>finaltexte        ;(mourning)
es_textcommon:  jsr printscreentext
                ;Determine lineup
                getbit PLOT_SADOK_JOIN
                pha
                getbit PLOT_GOAT_JOIN
                lsr
                pla
                rol
                pha
                getbit PLOT_JOAN_JOIN
                lsr
                pla
                rol

es_lineup:      asl
                tax
                lda lineupdataptr,x
                sta tempadrlo
                lda lineupdataptr+1,x
                sta tempadrhi
                ldy #$00
es_drawlineup:  lda (tempadrlo),y       ;X position
                beq es_drawfacedone
                tax
                lda #5                  ;Row counter
                sta temp1
                sta temp2               ;Column counter
                iny
                lda (tempadrlo),y       ;Whose face?
                iny
                clc
es_drawrow:     sta textscreen+7*40,x
                adc #$01
                inx
                dec temp2
                bne es_drawrow
                pha
                lda #5                  ;Reload column counter
                sta temp2
                txa
                adc #35
                tax
                pla
                dec temp1
                bne es_drawrow
                lda (tempadrlo),y       ;What instrument?
                pha
                iny
                sty temp1
                and #$03
                sta temp2
                asl
                asl
                adc temp2
                tay
                lda #5
                sta temp3
es_drawinstr:   lda instrtxt,y
                and #$3f
                sta textscreen+7*40,x
                inx
                iny
                dec temp3
                bne es_drawinstr
                pla
                and #VOCALS             ;Vocals?
                beq es_novocals
                lda #","
                sta textscreen+7*40-1,x
                ldy #15
                lda #5
                sta temp3
es_drawinstr2:  lda instrtxt,y
                and #$3f
                sta textscreen+7*40+35,x
                inx
                iny
                dec temp3
                bne es_drawinstr2
es_novocals:    ldy temp1
                jmp es_drawlineup
es_drawfacedone:lda es_acttcmp+1        ;False or ture agentmetal?
                cmp #ACT_IANCIVILIAN
                beq es_falseagentmetal
es_trueagentmetal:
                lda #<lineuptitle1
                ldy #>lineuptitle1
                bne es_agentcommon
es_falseagentmetal:
                lda #<lineuptitle2
                ldy #>lineuptitle2
es_agentcommon: jsr printscreentext
                jsr es_reveal
                lda #MSGTIME_ETERNAL
                jsr waitforfire
                jsr cleartextscreen
                lda #PANELMC1
                sta rgscr_textbg2+1
                lda #PANELMC2
                sta rgscr_textbg3+1
                jumpto SCRIPT_TITLE

es_reveal:      lda #$00
                sta agentcounter
es_revealloop:  jsr scriptupdateframe
                ldy agentcounter
                lda #$01
                sta colors+0*40,y
                sta colors+1*40,y
                sta colors+2*40,y
                sta colors+3*40,y
                sta colors+5*40,y
                sta colors+12*40,y
                sta colors+13*40,y
                sta colors+14*40,y
                sta colors+15*40,y
                sta colors+16*40,y
                sta colors+17*40,y
                lda #$09
                sta colors+7*40,y
                sta colors+8*40,y
                sta colors+9*40,y
                sta colors+10*40,y
                sta colors+11*40,y
                inc agentcounter
                lda agentcounter
                cmp #40
                bcc es_revealloop
                rts

printendnumber: sta temp3
                stx pen_x+1
                jsr convert8bits
                lda temp4
pen_x:          ldx #$00
printenddigits: pha
                lsr
                lsr
                lsr
                lsr
                ora #$30
                sta finaltext2,x
                inx
                pla
printenddigit:  and #$0f
                ora #$30
                sta finaltext2,x
                inx
                rts

                                ;012345678901234567890123456789
finaltexta:     dc.b 0,1,0,     " SO, AGENT, WALK ON THE CHOSEN",0
                dc.b 0,2,0,     "   PATH, THE SIGN OF THE GUN",0
                dc.b 0,3,0,     "        LIGHTS YOUR WAY",0,$ff

                                ;012345678901234567890123456789
finaltextb:     dc.b 0,1,0,     " ON MY JOURNEYS OF AND OUT OF",0
                dc.b 0,2,0,     "   THIS WORLD, I'VE SEEN THE",0
                dc.b 0,3,0,     "   THINGS BETTER LEFT UNTOLD",0,$ff

                                ;012345678901234567890123456789
finaltextc:     dc.b 0,0,0,     "   YET STILL THEY CONSPIRE,",0
                dc.b 0,1,0,     " SETTING THEIR WICKED SCHEMES,",0
                dc.b 0,2,0,     "  BUT WE HAVE LEARNED THINGS",0
                dc.b 0,3,0,     " AREN'T ALWAYS WHAT THEY SEEM",0,$ff

                                ;012345678901234567890123456789
finaltextd:     dc.b 0,0,0,     "   EVERYTHING I HAVE ALWAYS",0
                dc.b 0,1,0,     "WONDERED, I HAVE ALWAYS HOPED,",0
                dc.b 0,2,0,     "AND NOW, I KNOW. BUT THE TRUTH",0
                dc.b 0,3,0,     "        .. IS HIDDEN ..",0,$ff

                                ;012345678901234567890123456789
finaltexte:     dc.b 0,0,0,     "BUT WHAT WILL IT ALL LEAVE ME?",0
                dc.b 0,1,0,     "WHEN ALL THE ENEMIES HAVE BEEN",0
                dc.b 0,2,0,     " ELIMINATED, ALL CONSPIRACIES",0
                dc.b 0,3,0,     "  UNVEILED.. I WILL BE ALONE",0,$ff

finaltext2:     dc.b 6,15,0, "FINAL SCORE        ",0
                dc.b 6,16,0, "FINAL TIME   :  :  ",0,$ff

lineuptitle1:   dc.b 6,5,0, "AGENT METAL LINEUP",0,$ff
lineuptitle2:   dc.b 6,5,0, "FALSE AGENT LINEUP",0,$ff

lineupdataptr:  dc.w lineupdata0  ;I
                dc.w lineupdata1  ;IJ
                dc.w lineupdata2  ;IG
                dc.w lineupdata3  ;IJG
                dc.w lineupdata4  ;IS
                dc.w lineupdata5  ;IJS
                dc.w lineupdata6  ;IGS
                dc.w lineupdata7  ;IJGS

FI              = 64+50
FJ              = 64+25
FG              = 64+0
FS              = 64+75

GTR             = 0
BASS            = 1
DRUMS           = 2
VOCALS          = 4

lineupdata0:    dc.b 13,FI,GTR+VOCALS,0
lineupdata1:    dc.b 9,FI,BASS+VOCALS,16,FJ,GTR,0
lineupdata2:    dc.b 9,FI,GTR+VOCALS,16,FG,DRUMS,0
lineupdata3:    dc.b 6,FI,BASS+VOCALS,13,FG,DRUMS,20,FJ,GTR,0
lineupdata4:    dc.b 9,FI,GTR,16,FS,BASS+VOCALS,0
lineupdata5:    dc.b 6,FI,GTR,13,FS,BASS+VOCALS,20,FJ,GTR,0
lineupdata6:    dc.b 6,FI,GTR,13,FG,DRUMS,20,FS,BASS+VOCALS,0
lineupdata7:    dc.b 2,FI,GTR,9,FS,BASS+VOCALS,16,FG,DRUMS,23,FJ,GTR,0

instrtxt:       dc.b "GTRS.BASS DRUMSVOICE"

;-------------------------------------------------------------------------------
;$1e02
;-------------------------------------------------------------------------------

research:       lda #<ep1e02t
                ldy #>ep1e02t
                jmp compmsg

                                ;1234567890123456789012345678
ep1e02t:        dc.b 1,0,1,     "FROM: RESEARCH@IACPROJ.INNER",0
                dc.b 1,1,1,     "TO: AHRIMAN@CNTRL",0
                                ;1234567890123456789012345678
                dc.b 1,3,1,     "IT IS UNSETTLING TO REALIZE",0
                dc.b 1,4,1,     "HOW OLD THIS TEMPLE IS, AND",0
                dc.b 1,5,1,     "THUS HOW LONG THE SENTINELS",0
                dc.b 1,6,1,     "HAVE SPREAD THEIR INFLUENCE.",0
                dc.b 1,7,1,     "THESE WRITINGS DEPICT TOTAL",0
                dc.b 1,8,1,     "SUBMISSION TO THEIR IDEALS -",0
                dc.b 1,9,1,     "SUCH A WASTE OF POTENTIAL.",0
                dc.b 1,11,1,    "WITH THE REVERSE-ENGINEERING",0
                dc.b 1,12,1,    "PROJECT ALMOST COMPLETE, WE",0
                dc.b 1,13,1,    "WILL SOON BE ABLE TO ATTACK",0
                dc.b 1,14,1,    "THEIR SHIPS IN ORBIT.",0,$ff

                endscript
